
-- s13594, Bartosz Bednarowicz, 2015-09-24

/*
  1. Wybra wszystkie dane z tabeli SALGRADE.
  2. Wybra nazwiska i pensje tych pracownikw, ktrych zarobki mieszcz si w przedziale <1000, 2000> sortujc wedug pensji
  3. Wybra wszystkie wzajemnie rne stanowiska pracy.
  4. Wybra dane pracownikw zatrudnionych w departamentach 10 i 20 na stanowisku CLERK. wypisa w kolejnoci alfabetycznej ich nazwisk.
  5. Wybra nazwiska stanowiska i caoroczne dochody tych pracownikw, w ktrych nazwisku wystpuje cig liter TH lub LL i ktrzy posiadaj szefa.
  6. Wybra nazwiska, roczn pensj oraz prowizj tych wszystkich sprzedawcw, ktrych miesiczna pensja przekracza prowizj. Wyniki posortowa wedug malejcych zarobkw, potem nazwisk.
  ----------------------
  7. Dla wszystkich pracownikw wypisa numer i nazwisko, numer i nazw dziau oraz pensje
  8. Dla pracownikw z dziau mieszczcego si w New Yorku  wypisa numer i nazwisko, numer i nazw dziau oraz pensje 
  9. Dla kadego pracownika (podaj nazwisko) wypisz numer dziau, pensj oraz nazwisko i pensj jego kierownika. Kolumn z nazwiskiem kierownika nazwij Kierownik a jego pensj Pensja Kier- nieobowizkowe
*/

-- 1. Wybra wszystkie dane z tabeli SALGRADE.

SELECT * FROM SALGRADE;

-- 2. Wybra nazwiska i pensje tych pracownikw, ktrych zarobki mieszcz si w przedziale <1000, 2000> sortujc wedug pensji

SELECT
  ENAME AS "Pracownik",
  SAL + NVL(COMM,0) AS "Miesieczne wynagrodzenie"
FROM EMP
WHERE (SAL + NVL(COMM,0)) BETWEEN 1000 AND 2000
ORDER BY (SAL + NVL(COMM,0)) DESC;

-- 3. Wybra wszystkie wzajemnie rne stanowiska pracy.

SELECT DISTINCT
  JOB AS "Stanowisko"
FROM EMP ORDER BY JOB;

-- 4. Wybra dane pracownikw zatrudnionych w departamentach 10 i 20 na stanowisku CLERK. wypisa w kolejnoci alfabetycznej ich nazwisk.

SELECT *
FROM EMP
WHERE DEPTNO IN (10, 20) AND JOB = 'CLERK'
ORDER BY ENAME ASC;

-- 5. Wybra nazwiska stanowiska i caoroczne dochody tych pracownikw, w ktrych nazwisku wystpuje cig liter TH lub LL i ktrzy posiadaj szefa.

SELECT
  ENAME "Pracownik",
  JOB "Stanowisko",
  (SAL + NVL(COMM,0)) * 12 AS "Roczne wynagrodzenie"
FROM EMP
WHERE (ENAME LIKE '%TH%' OR ENAME LIKE '%LL%') AND NVL(MGR, 0) <> 0;

-- 6. Wybra nazwiska, roczn pensj oraz prowizj tych wszystkich sprzedawcw, ktrych miesiczna pensja przekracza prowizj. Wyniki posortowa wedug malejcych zarobkw, potem nazwisk.

SELECT
  ENAME "Pracownik",
  SAL * 12 AS "Annual sallary",
  NVL(COMM, 0) * 12 AS "Annual commission"
FROM EMP
WHERE JOB LIKE 'SALESMAN%' AND SAL > NVL(COMM, 0)
ORDER BY (SAL + NVL(COMM,0)) DESC, ENAME ASC;

-- 7. Dla wszystkich pracownikw wypisa numer i nazwisko, numer i nazw dziau oraz pensje

SELECT
  EMP.EMPNO "Pracownik Numer",
  EMP.ENAME "Pracownik",
  DEPT.DEPTNO "Departament numer",
  DEPT.DNAME "Departament nazwa",
  EMP.SAL "Pensja"
FROM EMP
  INNER JOIN DEPT ON
    EMP.DEPTNO = DEPT.DEPTNO
ORDER BY ENAME ASC;
  
-- 8. Dla pracownikw z dziau mieszczcego si w New Yorku  wypisa numer i nazwisko, numer i nazw dziau oraz pensje

SELECT
  EMP.EMPNO "Pracownik Numer",
  EMP.ENAME "Pracownik",
  DEPT.DEPTNO "Departament numer",
  DEPT.DNAME "Departament nazwa",
  EMP.SAL "Pensja"
FROM EMP
  INNER JOIN DEPT ON
    EMP.DEPTNO = DEPT.DEPTNO AND
    DEPT.LOC LIKE 'NEW YORK%'
ORDER BY EMP.ENAME ASC;

-- 9. Dla kadego pracownika (podaj nazwisko) wypisz numer dziau, pensj oraz nazwisko i pensj jego kierownika. Kolumn z nazwiskiem kierownika nazwij Kierownik a jego pensj Pensja Kier- nieobowizkowe

SELECT
  E1.ENAME AS "Pracownik",
  E1.DEPTNO AS "Dzial",
  E1.SAL AS "Pensja",
  E2.ENAME AS "Kierownik",
  E2.SAL AS "Pensja Kierownika"
FROM EMP "E1"
  LEFT JOIN EMP "E2" ON
    E1.MGR = E2.EMPNO
ORDER BY E1.ENAME ASC;


/**
 * 
 * FIN :-)
 *
 **/
    
